﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System.ComponentModel;
using System.Collections;
using System.Windows.Markup;

namespace CustomFieldTypeProperty
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            FieldSettingsEx fse = new FieldSettingsEx();
            fse.AllowEdit = false;
            fse.CellWidth = 180;
            fse.FieldDisplayType = FieldDisplayType.ComboBox;
            fse.DisplayPath = "Name";
            fse.ValuePath = "Name";
            fse.CombSource = new ComboDataSource();

            xamDataGrid1.DefaultFieldLayout.Fields["department"].Settings = fse;

            comboBox1.SetBinding(ComboBox.SelectedItemProperty, new Binding("DefaultFieldLayout.Fields[department].Settings.FieldDisplayType") { Mode = BindingMode.TwoWay, ElementName = "xamDataGrid1" });

            comboBox1.ItemsSource = Enum.GetValues(typeof(FieldDisplayType));

            Style style = new Style(typeof(DifferentViewEditor));
            ControlTemplate template = new ControlTemplate(typeof(DifferentViewEditor));

            FrameworkElementFactory border = new FrameworkElementFactory(typeof(Border));
            template.VisualTree = border;            

            FrameworkElementFactory grid = new FrameworkElementFactory(typeof(Grid));
            border.AppendChild(grid);

            grid.SetValue(Grid.MarginProperty, new Thickness(2));

            FrameworkElementFactory button = new FrameworkElementFactory(typeof(Button));
            button.Name = "btn";
            button.SetValue(Button.ContentProperty, new TemplateBindingExtension(DifferentViewEditor.ValueProperty));
            grid.AppendChild(button);

            FrameworkElementFactory radio = new FrameworkElementFactory(typeof(RadioButton));
            radio.Name = "radio";
            radio.SetValue(RadioButton.ContentProperty, new TemplateBindingExtension(DifferentViewEditor.ValueProperty));
            radio.SetValue(RadioButton.GroupNameProperty, "group");
            grid.AppendChild(radio);

            FrameworkElementFactory check = new FrameworkElementFactory(typeof(CheckBox));
            check.Name = "check";
            check.SetValue(CheckBox.ContentProperty, new TemplateBindingExtension(DifferentViewEditor.ValueProperty));
            grid.AppendChild(check);

            FrameworkElementFactory combo = new FrameworkElementFactory(typeof(ComboBox));
            combo.Name = "combo";
            combo.SetBinding(ComboBox.ItemsSourceProperty, new Binding() { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) }, Path = new PropertyPath("Field.Settings.CombSource") });
            combo.SetBinding(ComboBox.DisplayMemberPathProperty, new Binding() { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) }, Path = new PropertyPath("Field.Settings.DisplayPath") });
            combo.SetBinding(ComboBox.SelectedValuePathProperty, new Binding() { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) }, Path = new PropertyPath("Field.Settings.ValuePath") });
            combo.SetBinding(ComboBox.SelectedValueProperty, new Binding() { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) }, Path = new PropertyPath("Value"), Mode = BindingMode.TwoWay });
            grid.AppendChild(combo);                       

            DataTrigger buttonDT = new DataTrigger();
            buttonDT.Binding = new Binding("Field.Settings.FieldDisplayType") { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) } };
            buttonDT.Value = "Button";

            buttonDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty,Visibility.Visible,"btn"));
            buttonDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty,Visibility.Collapsed,"check"));
            buttonDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty,Visibility.Collapsed,"combo"));
            buttonDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty,Visibility.Collapsed,"radio"));

            template.Triggers.Add(buttonDT);

            DataTrigger radioDT = new DataTrigger();
            radioDT.Binding = new Binding("Field.Settings.FieldDisplayType") { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) } };
            radioDT.Value = "RadioButton";

            radioDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "btn"));
            radioDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "check"));
            radioDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "combo"));
            radioDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Visible, "radio"));

            template.Triggers.Add(radioDT);

            DataTrigger checkDT = new DataTrigger();
            checkDT.Binding = new Binding("Field.Settings.FieldDisplayType") { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) } };
            checkDT.Value = "CheckBox";

            checkDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "btn"));
            checkDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Visible, "check"));
            checkDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "combo"));
            checkDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "radio"));

            template.Triggers.Add(checkDT);            

            DataTrigger comboDT = new DataTrigger();
            comboDT.Binding = new Binding("Field.Settings.FieldDisplayType") { RelativeSource = new RelativeSource() { AncestorType = typeof(CellValuePresenter) } };
            comboDT.Value = "ComboBox";

            comboDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "btn"));
            comboDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "check"));
            comboDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Visible, "combo"));
            comboDT.Setters.Add(new Setter(FrameworkElement.VisibilityProperty, Visibility.Collapsed, "radio"));

            template.Triggers.Add(comboDT);

            style.Setters.Add(new Setter(DifferentViewEditor.TemplateProperty, template));
            this.Resources.Add(typeof(DifferentViewEditor), style);
                       

        }
    }

    public class FieldSettingsEx : FieldSettings
    {
        //Hiding the original properties to prevent changes on the editor of the field.
        public Type EditorType { get { return null; } }
        public Style EditorStyle { get { return null; } }
        public Type EditAsType { get { return null; } }

        public FieldSettingsEx()
        {
            base.EditorType = typeof(DifferentViewEditor);           
        }

        #region FieldDisplayTypeProperty
        public FieldDisplayType FieldDisplayType
        {
            get { return (FieldDisplayType)GetValue(FieldDisplayTypeProperty); }
            set { SetValue(FieldDisplayTypeProperty, value); }
        }

        // Using a DependencyProperty as the backing store for FieldDisplayType.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty FieldDisplayTypeProperty =
            DependencyProperty.Register(
                    "FieldDisplayType",
                    typeof(FieldDisplayType),
                    typeof(FieldSettingsEx),
                    new UIPropertyMetadata(
                        FieldDisplayType.Button,
                        new PropertyChangedCallback(
                            (o, e) =>
                            {
                                (o as FieldSettingsEx).OnPropertyChagned("FieldDisplayType");
                            })));
        #endregion

        #region ComboBox Properties
        public string DisplayPath { get; set; }
        public string ValuePath { get; set; }
        public IEnumerable CombSource { get; set; }
        #endregion

        #region INotifyPropertyChanged members
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChagned(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
        #endregion
    }

    public enum FieldDisplayType
    {
        ComboBox,
        CheckBox,
        Button,
        RadioButton
    }

    public class DifferentViewEditor : ValueEditor
    {
        public override bool CanEditType(Type type)
        {
            return false;
        }

        public override bool CanRenderType(Type type)
        {
            return false;
        }
    }




    public class ComboDataSource : List<Data>
    {
        public ComboDataSource()
        {
            Add(new Data { Name = "Sales" });
            Add(new Data { Name = "Human Resources" });
            Add(new Data { Name = "Admin" });
            Add(new Data { Name = "Accounting" });
            Add(new Data { Name = "Board of Directors" });
        }
    }

    public class Data
    {
        public string Name { get; set; }
    }
}
